
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/*
 * open_socket - establish a stream socket connection to the nominated
 * host and port.
 */
static int
open_socket(dest)
    char *dest;
{
    char *sep, *endp = NULL;
    int sock, port = -1;
    u_int32_t host;
    struct hostent *hent;
    struct sockaddr_in sad;

    /* parse host:port and resolve host to an IP address */
    sep = strchr(dest, ':');
    if (sep != NULL)
	port = strtol(sep+1, &endp, 10);
    if (port < 0 || endp == sep+1 || sep == dest) {
	fprintf(stderr, "Can't parse host:port for socket destination\n");
	return -1;
    }
    *sep = 0;
    host = inet_addr(dest);
    if (host == (u_int32_t) -1) {
	hent = gethostbyname(dest);
	if (hent == NULL) {
	    fprintf(stderr, "%s: unknown host in socket option\n", dest);
	    *sep = ':';
	    return -1;
	}
	host = *(u_int32_t *)(hent->h_addr_list[0]);
    }
    *sep = ':';

    /* get a socket and connect it to the other end */
    sock = socket(PF_INET, SOCK_STREAM, 0);
    if (sock < 0) {
	perror("Can't create socket");
	return -1;
    }
    memset(&sad, 0, sizeof(sad));
    sad.sin_family = AF_INET;
    sad.sin_port = htons(port);
    sad.sin_addr.s_addr = host;
    if (connect(sock, (struct sockaddr *)&sad, sizeof(sad)) < 0) {
	perror("Can't connect");
	close(sock);
	return -1;
    }

    setsockopt(sock, SOL_SOCKET, SO_RCVBUF, &window, sizeof(int));

    return sock;
}

if (socket_addr) {
		int sockfd = open_socket(socket_addr);
		if (sockfd < 0)
			exit(1);
		nb = fread(buffer, 1, BUFFER_SIZE, in_file);
		if (nb > 0)
			write(sockfd, buffer, nb);
		shutdown(fd, SHUT_WR);
		fd = sockfd;
}
